function a = gradient_to_guide(a, sigma_vertical, sigma_horizontal, dark, light);
% processes the gradient image of a synthtetic plank from gaussian blob
% level lines to give a shape similar to first_set/Matching  images
% sigma is the length of the structuring element for dilation
% dark and light are colors for painting
%
% author jlezama@fing.edu.uy

%% dilate
a = logical(a);

se = strel(ones(sigma_vertical,sigma_horizontal));

a = imdilate(a, se);




%% define colors
assert(size(dark,1)==size(light,1));
Ncolors = size(dark,1);

%% paint each connected component
[H, W] = size(a);
red = zeros(H, W);
green = zeros(H, W);
blue = zeros(H, W);

l_fine = bwlabel(a);
l_coarse = bwlabel(~a);

%figure;
for i=1:max(l_fine(:));
    c = randi(Ncolors);
    z = find(l_fine==i);
    
    colors = dark;
    
    red(z) = colors(c,1);
    green(z) = colors(c,2);
    blue(z) = colors(c,3);
    
    %imshow(cat(3, red, green, blue))
    %pause(.1)
end

for i=1:max(l_coarse(:));
    c = randi(Ncolors);
    z = find(l_coarse==i);
    
    colors = light;
    
    red(z) = colors(c,1);
    green(z) = colors(c,2);
    blue(z) = colors(c,3);
    
    %imshow(cat(3, red, green, blue))
    %pause(.1)
end

a = cat(3, red, green, blue);
%imdisplay(a)







