%% Guide generator Version 1 - level set method
function [] = guide_generator(output1,output2,output3,output4,H_txt,...
    W_txt,sig_b1_txt,sig_b2_txt,sig_dip_txt,max_disp_txt,...
    blob_vert_pos1_txt,blob_vert_pos2_txt,blob_hor_pos1_txt,...
    blob_hor_pos2_txt,num_int_txt,blob_mult1_txt,blob_mult2_txt,...
    dil_vert_txt,dil_hor_txt,surf_decay_txt,vert_disp_mult_txt,...
    sig1_11_txt,sig1_22_txt,sig1_12_txt,sig2_11_txt,sig2_22_txt,sig2_12_txt)

%warning('off','all');

% H = 4552; % height --> final 4096
% W = 568; % width --> final 512
% sigma_blob = [3000 2000];%random_choose([200, 400, 800, 1200], 2); % 300
% sigma_disp = random_choose([25, 75, 50, 100]); 
% max_disp = random_choose([ 4, 6, 8 ,12]);
% blob_vert_pos =  [2/8 31/32];%random_choose([0 1/4 1/3 1/2 2/3 3/4 1], 2) ;
% blob_hor_pos = [1/4 1/2];%random_choose([0 1/4 1/3 1/2 2/3 3/4 1], 2);
% num_int = 20;%random_choose([15, 20, 30] );
% blob_mult = [1 0];%random_choose([0,0.5,  1, 2],2);
% dilat_vert = 10;%random_choose([6, 10, 12]);
% dilat_hor = 2;%random_choose([6, 10, 12]);
% surf_decay = 1.5;%random_choose([1, 1.5, 2, 3]);
% vert_disp_mult = random_choose([8, 10, 12]);

% parameters
% Set dimensions of the plank
H = str2double(H_txt); % height --> final 4096
W = str2double(W_txt); % width --> final 512

% Set parameters for guides g1 and g2
sigma_blob = [str2double(sig_b1_txt) str2double(sig_b2_txt)];%
sigma_disp = str2double(sig_dip_txt); 
max_disp = str2double(max_disp_txt);
blob_vert_pos =  [str2double(blob_vert_pos1_txt) str2double(blob_vert_pos2_txt)];
blob_hor_pos = [str2double(blob_hor_pos1_txt) str2double(blob_hor_pos2_txt)];
num_int = str2double(num_int_txt);
blob_mult = [str2double(blob_mult1_txt) str2double(blob_mult2_txt)];
dilat_vert = str2double(dil_vert_txt);
dilat_hor = str2double(dil_hor_txt);
surf_decay = str2double(surf_decay_txt);
vert_disp_mult = str2double(vert_disp_mult_txt);
sig1_11 = str2double(sig1_11_txt);%30;
sig1_22 = str2double(sig1_22_txt);%7;
sig1_12 = str2double(sig1_12_txt);%0;
sig2_11 = str2double(sig2_11_txt);%2;
sig2_22 = str2double(sig2_22_txt);%70;
sig2_12 = str2double(sig2_12_txt);%0;

params = [H W sigma_blob sigma_disp max_disp blob_vert_pos ...
    blob_hor_pos num_int blob_mult dilat_vert dilat_hor surf_decay...
    vert_disp_mult sig1_11 sig1_22 sig1_12 sig2_11 sig2_22 sig2_12];

[s1,s2,s3,s4] = generate_guide_ipol(params);

% Create indexed image, explicitly using 256 colors
imInd=gray2ind(s1,256);
% Convert indexed image to RGB using 256-colors jet map
jetRGB=ind2rgb(imInd,jet(256));
% Save image
imwrite(jetRGB,output1);
% Create indexed image, explicitly using 256 colors
imInd=gray2ind(s2,256);
% Convert indexed image to RGB using 256-colors jet map
jetRGB=ind2rgb(imInd,jet(256));
% Save image
imwrite(jetRGB, output2);

%imwrite(s1, jet, output1);
%imwrite(s2, output2);
imwrite(s3, output3);
imwrite(s4, output4);

%display(version)
%display(max(s1(:)))
%display(min(s1(:)))